BEGIN { 
	 inJML = 0; 
	 curInv = "";
}

/^\W*(public)|(private)|(protected)/ { 
	 if (!index($0, " class ")) { 
				for (i=1; i<=NF; i++) $(i)=$i; 
				print "\n\n=== METHOD: ", $0, "===";
		  } 
}

/\/\/@ loop_invariant/ { 
	 for (i=3; i<=NF; i++) $(i-2)=$i; 
	 NF=NF-2; 
	 print "\nINVARIANT: "$0
}

/\/\*@ loop_invariant/ { 
	 if (!inJML) { 
				inJML=1; 
				curInv=""; 
		  }; 
		  for (i=3; i<=NF; i++) curInv=(curInv " "$i); 
}

/[^\*]@ loop_invariant / { 
	 if (inJML) { 
				print "\nINVARIANT: ", curInv; 
				curInv=""; 
				for (i=3; i<=NF; i++) curInv=(curInv " "$i);
		  } 
}

/[^\*]@  / { 
	 if (inJML) {
				for (i=2; i<=NF; i++) curInv=(curInv " "$i);
		  } 
}

/@\*\// { 
	 if (inJML) {
				inJML=0; 
				sub(/@\*\//, "", curInv); 
				print "\nINVARIANT: ", curInv;
		  } 
}
